<script setup>
import { useRouter } from 'vue-router'
import { ref } from 'vue'

import { CdxButton } from '@wikimedia/codex';
import { toast } from 'vue3-toastify';
import 'vue3-toastify/dist/index.css';
import { useCookies} from 'vue3-cookies';
import { useInstrumentStore } from '../stores/instrument.js'

// Import child form components
import Function from './form/Function.vue'
import Details from './form/Details.vue'
import Duration from './form/Duration.vue'
import Regulation from './form/Regulation.vue'

const { cookies } = useCookies();

const router = useRouter();
const store = useInstrumentStore();
const successMessage = ref(null);

// Function data
store.formFunction = 'template';


async function submit() {
    const formData = Object.assign({
        csrf_token: cookies.get('csrf_token'),
    }, store.instrument);

    const response = await store.saveInstrument(formData, 'new');
    toast(response.data.title, {
        type: response.success ? 'success' : 'error',
        position: 'bottom-right',
        autoClose: 2000,
    });

    if (response.success) {
        const instrumentName = formData.name;
        store.setSuccessMessage(`The instrument ${instrumentName} has been successfully launched.`);
        // Redirect to the List.vue
        router.push({ name: 'catalog' });
    }
}
</script> 

<template>
    <!-- HEADER -->
    <div class="subheader">
        <h1 class="title">Launch your instrument: {{ store.instrument.name }}</h1>
        <div class="subtitle">Use this form to configure your instruments and start collecting data.</div>
    </div>
    <div class="body">
        <form @submit.prevent="submit">
            <!-- GET STARTED SECTION -->
            <div class="section">
                <Function />
            </div>

            <!-- DETAILS SECTION -->
            <div class="section">
                <Details />
            </div>

            <!-- DURATION SECTION -->
            <div class="section">
                <Duration />
            </div>

            <!-- REGULATION SECTION -->
            <div class="section">
                <Regulation />
            </div>

            <!-- SUBMIT -->
            <div class="section-last">
                <cdx-button action="progressive" weight="primary">
                    Launch instrument
                </cdx-button>
            </div>
        </form>
    </div>
</template>
